"use strict";
this.name	= "hdbg";
this.author	= "Norby";
this.copyright	= "2015 Norby";
this.description= "HD Backgrounds on Arrival Reports";
this.licence	= "CC BY-NC-SA 4.0";

this.$Roles = []; //fill in scripts of image packs after the 0. image of unknown stations
this.$R = [{ role:"unknown", file:"Dead_End_Final_by_Kheng_Teoh.png", x:1024, y:768, zoom:1,
		author:"Kheng Teoh", title:"Dead End",
		license:"no problem as long as you use cite the source",
		source:"http://kheng.deviantart.com/art/Dead-End-Final-9278839"
	}];
	
//worldscript events
this.startUp = function() {
	var w = worldScripts.hdbg;
	if( w ) w.$AddRoles(this.$R);
}

this.guiScreenChanged = function(to, from) {
	var ps = player.ship;
	if( ps.docked && from == "GUI_SCREEN_REPORT" ) ps.hudHidden = false; //restore HUD
	if( !ps.docked || to != "GUI_SCREEN_REPORT" && to != "GUI_SCREEN_MISSION" ) return;

	var id = -1;
	if( mission && mission.screenID && mission.screenID.indexOf("hdbg-") == 0 ) {
		//mission screen requested a HD background?
		var m = mission.screenID;
		if( m == "hdbg-station" ) id = 0; //select image of the station below
		else for( var i = 0; i < len; i++ ) {
			var r = this.$Roles[i];
			if( r && r.role && "hdbg-"+r.role == m ) { //like hdbg-coriolis
				id = i; //found station role
				i = len; //exit from for cycle
			}
		}
	}
	if( to == "GUI_SCREEN_MISSION" && id == -1 ) return; //no supported screenID

	if( id < 0 ) id = 0; //0. item in $ID is "unknown"
	if( id == 0 ) { //arrival report or unspecified missionscreen with HD background
		var s = ps.dockedStation;
		var len = this.$Roles.length;
		if( s && s.hasRole ) for( var i = 0; i < len; i++ ) {
			var r = this.$Roles[i];
			if( r && r.role && s.hasRole( r.role ) ) {
				id = i; //found station role
				i = len; //exit from for cycle
			}
		}
	}

	var p = this.$Roles[id];
	if( !this.$SetHDBG( p.file, p.x, p.y, p.zoom ) ) { //show in the real size in fullHD
		var q = this.$Roles[0];  //fallback to the 0. image (defined above)
		this.$SetHDBG( q.file, q.x, q.y, q.zoom );
	}
	if( to == "GUI_SCREEN_REPORT" ) ps.hudHidden = true; //hide HUD for HD images
}

//HDBG functions
this.$AddRoles = function(roles) { //called by image packs, roles must be an array!
	var h = worldScripts.hdbg;
	var w = worldScripts.XenonUI;
	if( roles && roles.length ) for( var i = 0; i < roles.length; i++ ) {
		var ri = roles[i];
		var ro = ri.role;
		if( ro && ri.file ) { //at least role and filename is needed
			h.$Roles.push(ri);
			if (w) w.$addMissionScreenException("hdbg-"+ro);
		}
	}
}

this.$SetHDBG = function(pic, x, y, zoom) {  //show pic in real size in fullHD
	var he = 480;
	var wi = 0;
	
	//determine screen ratio
	var o = oolite.gameSettings.gameWindow;
//	if(o.width > 1.55 * o.height && o.width < 1.75 * o.height) {
		//todo in 16:10
//	}
	var r = o.width / o.height; //screen ratio, 1.6 mean 16:10
	if( x > 0 && y > 0 ) { //can stretch only if image sizes are given
		if( x / y < r ) { //image is narrower than the screen
			if( zoom < 0 ) wi = 0; //zoom out, fit height and leave black side bars
			else {
				if( zoom > 0 ) he = 0; //zoom (fit width, crop at top and bottom)
				wi = r * 480; //or stretch horizontally without zoom,
			}
			//for example a 4:3 image in 16:9 screen will be stretched
		} else if( zoom < 0 ) { //image is wider than the screen
			//zoom out, fit width and leave black bars at top and bottom
			he = 0;
			wi = r * 480; 
		} else {  //zoom (fit height, crop at sides)
			if( !zoom ) wi = r * 480; //shrink horizontally if no zoom and too wide
			//for example a 16:9 image in 4:3 screen will be shrinked
		}
	} //without image sizes fit to the height, crop if too wide or leave black bars if narrow
	
//	log(this.name, "setHDBG "+pic+" "+x+"x"+y+" wid:"+wid);
	if( wi == 0 && he > 0 ) 
		return( setScreenBackground({ name: pic, height: he }) );
	else if( wi > 0 && he == 0 ) 
		return( setScreenBackground({ name: pic, width: wi }) );
	else return( setScreenBackground({ name: pic, height: he , width: wi }) );
}